import { GrpcCoin, Pagination } from '../../../types';
import { Coin } from '../../../types';
import { QueryAllBalancesResponse, QueryBalanceResponse, QueryTotalSupplyResponse, QueryParamsResponse as QueryBankParamsResponse } from '@routerprotocol/chain-api/cosmos/bank/v1beta1/query_pb';
import { BankModuleParams, TotalSupply } from '../types';
export declare class ChainGrpcBankTransformer {
    static grpcCoinToCoin(coin: GrpcCoin): Coin;
    static grpcCoinsToCoins(coins: GrpcCoin[]): Coin[];
    static moduleParamsResponseToModuleParams(response: QueryBankParamsResponse): BankModuleParams;
    static totalSupplyResponseToTotalSupply(response: QueryTotalSupplyResponse): {
        supply: TotalSupply;
        pagination: Pagination;
    };
    static balanceResponseToBalance(response: QueryBalanceResponse): Coin;
    static balancesResponseToBalances(response: QueryAllBalancesResponse): {
        balances: Coin[];
        pagination: Pagination;
    };
}
